// Modify the displayed message to clarify where safelinks are
// inserted and to show the actual link targets.

function getTextNodes(elem) {
    var result = [];
    if (elem) {
	for (var nodes = elem.childNodes, i = nodes.length; i--;) {
	    let node = nodes[i];
	    let nodeType = node.nodeType;
	    
	    if (nodeType == Node.TEXT_NODE) {
		result.push(node);
	    }
	    else if (nodeType == Node.ELEMENT_NODE
		     || nodeType == Node.DOCUMENT_NODE
		     || nodeType == Node.DOCUMENT_FRAGMENT_NODE) {
		result = result.concat(getTextNodes(node));
	    }
	}
    }
    return result;
}

for (const link of document.links) {
    // Mangle the link text
    for (const node of getTextNodes(link)) {
	node.textContent = untangleLink(node.textContent);
    }

    // Generate the tooltip and set link class
    if (isTangledLink(link.href)) {
	let tooltiptext = untangleLink(link.href);
	let tooltip = document.createElement('span');
	tooltip.classList.add('liu_safelinks_tooltip');
	tooltip.textContent = tooltiptext;
	link.classList.add('liu_safelinks_link');
	link.prepend(tooltip);
    }
}
